'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var classer = require('@code-hike/classer');
var utils = require('@code-hike/utils');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

var MiniFrame = React__default['default'].forwardRef(function (_a, ref) {
    var title = _a.title, children = _a.children, titleBar = _a.titleBar, classes = _a.classes, theme = _a.theme, _b = _a.zoom, zoom = _b === void 0 ? 1 : _b, overflow = _a.overflow, props = __rest(_a, ["title", "children", "titleBar", "classes", "theme", "zoom", "overflow"]);
    var c = classer.useClasser("ch-frame", classes);
    var bar = titleBar || React__default['default'].createElement(DefaultTitleBar, { title: title });
    var zoomStyle = {
        "--ch-frame-zoom": zoom,
        overflow: overflow,
    };
    return (React__default['default'].createElement(classer.ClasserProvider, { classes: classes },
        React__default['default'].createElement("div", __assign({}, props, { ref: ref }),
            React__default['default'].createElement("div", { className: c("") },
                React__default['default'].createElement("div", { className: c("title-bar"), style: {
                        background: utils.getColor(theme, utils.ColorName.EditorGroupHeaderBackground),
                    } }, bar),
                React__default['default'].createElement("div", { className: c("content") },
                    React__default['default'].createElement("div", { className: c("zoom"), style: zoomStyle }, children))))));
});
var SimpleFrame = React__default['default'].forwardRef(function (_a, ref) {
    var title = _a.title, children = _a.children, titleBar = _a.titleBar, classes = _a.classes; _a.overflow; var props = __rest(_a, ["title", "children", "titleBar", "classes", "overflow"]);
    var c = classer.useClasser("ch", classes);
    var bar = titleBar || React__default['default'].createElement(DefaultTitleBar, { title: title });
    return (React__default['default'].createElement(classer.ClasserProvider, { classes: classes },
        React__default['default'].createElement("div", __assign({}, props, { ref: ref }),
            React__default['default'].createElement("div", { className: c("simple-frame") },
                React__default['default'].createElement("div", { className: c("frame-title-bar") }, bar),
                children))));
});
function DefaultTitleBar(_a) {
    var title = _a.title;
    var c = classer.useClasser("ch-frame");
    return (React__default['default'].createElement(React__default['default'].Fragment, null,
        React__default['default'].createElement("div", { className: c("left-bar") },
            React__default['default'].createElement(FrameButtons, null)),
        React__default['default'].createElement("div", { className: c("middle-bar") }, title),
        React__default['default'].createElement("div", { className: c("right-bar") })));
}
function FrameButtons() {
    var c = classer.useClasser("ch-frame");
    return (React__default['default'].createElement("div", { className: c("buttons") },
        React__default['default'].createElement("div", { className: c("button", "button-left") }),
        React__default['default'].createElement("div", { className: c("button-space") }),
        React__default['default'].createElement("div", { className: c("button", "button-middle") }),
        React__default['default'].createElement("div", { className: c("button-space") }),
        React__default['default'].createElement("div", { className: c("button", "button-right") })));
}

exports.FrameButtons = FrameButtons;
exports.MiniFrame = MiniFrame;
exports.SimpleFrame = SimpleFrame;
